Index: /trunk/src/org/expeditee/actions/Actions.java
===================================================================
--- /trunk/src/org/expeditee/actions/Actions.java	(revision 120)
+++ /trunk/src/org/expeditee/actions/Actions.java	(revision 121)
@@ -19,7 +19,7 @@
 import org.expeditee.gui.DisplayIO;
 import org.expeditee.gui.Frame;
-import org.expeditee.gui.FrameGraphics;
 import org.expeditee.gui.FrameIO;
 import org.expeditee.gui.FrameUtils;
+import org.expeditee.gui.MessageBay;
 import org.expeditee.io.Conversion;
 import org.expeditee.io.Logger;
@@ -315,5 +315,5 @@
 		// check for protection on frame
 		if (ItemUtils.ContainsTag(source.getItems(), "@No" + mname)) {
-			FrameGraphics.DisplayMessage("Frame is protected by @No" + mname
+			MessageBay.displayMessage("Frame is protected by @No" + mname
 					+ " tag.");
 			return;
@@ -365,8 +365,8 @@
 		}
 		if (possibles.size() > 0) {
-			FrameGraphics.ErrorMessage("Incorrect parameters for " + mname);
+			MessageBay.errorMessage("Incorrect parameters for " + mname);
 		} else {
 			assert (false);
-			FrameGraphics.ErrorMessage(mname + " action not found");
+			MessageBay.errorMessage(mname + " action not found");
 		}
 	}
@@ -431,5 +431,5 @@
 			// if there is no constructor, return
 			if (con == null) {
-				FrameGraphics.DisplayMessage(INVALID_PARAMETERS_ERROR
+				MessageBay.displayMessage(INVALID_PARAMETERS_ERROR
 						+ nameWithCorrectCase);
 				// System.out.println("Constructor not found...");
@@ -445,5 +445,5 @@
 			// check for errors during initialisation
 			if (!_Agent.initialise(source)) {
-				FrameGraphics.ErrorMessage("Error initialising agent: "
+				MessageBay.errorMessage("Error initialising agent: "
 						+ nameWithCorrectCase);
 				return;
@@ -461,8 +461,8 @@
 
 		} catch (ClassNotFoundException cnf) {
-			FrameGraphics.ErrorMessage(nameWithCorrectCase
+			MessageBay.errorMessage(nameWithCorrectCase
 					+ "' is not an action or agent.");
 		} catch (Exception e) {
-			FrameGraphics.ErrorMessage("Error creating Agent: '"
+			MessageBay.errorMessage("Error creating Agent: '"
 					+ nameWithCorrectCase + "'");
 			System.out.println("Agent set to Null.");
@@ -494,5 +494,5 @@
 	public static void stopAgent() {
 		if (_Agent != null && _Agent.isRunning()) {
-			FrameGraphics.ErrorMessage("Stopping Agent...");
+			MessageBay.errorMessage("Stopping Agent...");
 			_Agent.stop();
 		}
Index: /trunk/src/org/expeditee/actions/IDE.java
===================================================================
--- /trunk/src/org/expeditee/actions/IDE.java	(revision 120)
+++ /trunk/src/org/expeditee/actions/IDE.java	(revision 121)
@@ -8,5 +8,5 @@
 import org.expeditee.gui.DisplayIO;
 import org.expeditee.gui.Frame;
-import org.expeditee.gui.FrameGraphics;
+import org.expeditee.gui.MessageBay;
 
 public class IDE {
@@ -23,10 +23,10 @@
 			try {
 				Runtime.getRuntime().exec("javac -d expeditee/bin " + fileName);
-				FrameGraphics.DisplayMessage("Compiled " + fileName, Color.darkGray);
+				MessageBay.displayMessage("Compiled " + fileName, Color.darkGray);
 			} catch (Exception e) {
-				FrameGraphics.ErrorMessage("Could not compile class!");
+				MessageBay.errorMessage("Could not compile class!");
 			}
 		} else {
-			FrameGraphics.ErrorMessage("Could not initialise agent!");
+			MessageBay.errorMessage("Could not initialise agent!");
 		}
 	}
@@ -50,11 +50,11 @@
 			String message = "";
 			while ((message = stdInput.readLine()) != null) {
-				FrameGraphics.DisplayMessage(message);
+				MessageBay.displayMessage(message);
 			}
 			while ((message = stdError.readLine()) != null) {
-				FrameGraphics.ErrorMessage(message);
+				MessageBay.errorMessage(message);
 			}
 		} catch (Exception e) {
-			FrameGraphics.ErrorMessage("Could not run class!");
+			MessageBay.errorMessage("Could not run class!");
 		}
 	}
Index: /trunk/src/org/expeditee/actions/Misc.java
===================================================================
--- /trunk/src/org/expeditee/actions/Misc.java	(revision 120)
+++ /trunk/src/org/expeditee/actions/Misc.java	(revision 121)
@@ -20,4 +20,5 @@
 import org.expeditee.gui.FrameIO;
 import org.expeditee.gui.FrameMouseActions;
+import org.expeditee.gui.MessageBay;
 import org.expeditee.gui.TimeKeeper;
 import org.expeditee.items.Item;
@@ -55,5 +56,5 @@
 	public static void Restore() {
 		FrameIO.Reload();
-		// FrameGraphics.DisplayMessage("Restoration complete.");
+		// MessageBay.displayMessage("Restoration complete.");
 	}
 
@@ -144,5 +145,5 @@
 				DisplayIO.Back();
 				FrameGraphics.Repaint();
-				FrameGraphics.DisplayMessage(deletedFrame + " deleted");
+				MessageBay.displayMessage(deletedFrame + " deleted");
 				return;
 			}
@@ -156,5 +157,5 @@
 			e.printStackTrace();
 		}
-		FrameGraphics.ErrorMessage(errorMessage);
+		MessageBay.errorMessage(errorMessage);
 	}
 
@@ -249,9 +250,9 @@
 	public static void GetCometStats(Frame frame) {
 		TimeKeeper timer = new TimeKeeper();
-		FrameGraphics.DisplayMessage("Computing comet stats...");
+		MessageBay.displayMessage("Computing comet stats...");
 
 		CometStats cometStats = new CometStats(frame);
 		attachStatsToCursor(cometStats.toString());
-		FrameGraphics.OverwriteMessage("Comet stats time: "
+		MessageBay.overwriteMessage("Comet stats time: "
 				+ timer.getElapsedStringSeconds());
 	}
@@ -259,9 +260,9 @@
 	public static void GetTreeStats(Frame frame) {
 		TimeKeeper timer = new TimeKeeper();
-		FrameGraphics.DisplayMessage("Computing tree stats...");
+		MessageBay.displayMessage("Computing tree stats...");
 
 		TreeStats treeStats = new TreeStats(frame);
 		attachStatsToCursor(treeStats.toString());
-		FrameGraphics.OverwriteMessage("Tree stats time: "
+		MessageBay.overwriteMessage("Tree stats time: "
 				+ timer.getElapsedStringSeconds());
 	}
@@ -473,12 +474,12 @@
 			String frameName = ImageFrame(loaded, format, path);
 			if (frameName != null)
-				FrameGraphics.DisplayMessage("Frame successfully saved to "
+				MessageBay.displayMessage("Frame successfully saved to "
 						+ path + frameName);
 			else
-				FrameGraphics.ErrorMessage("Could not find image writer for "
+				MessageBay.errorMessage("Could not find image writer for "
 						+ format + " format");
 			// if the frame was not loaded successfully, alert the user
 		} else
-			FrameGraphics.DisplayMessage("Frame '" + framename
+			MessageBay.displayMessage("Frame '" + framename
 					+ "' could not be found.");
 	}
@@ -491,9 +492,9 @@
 	 */
 	public static void MessageLn(String message) {
-		FrameGraphics.DisplayMessage(message);
+		MessageBay.displayMessage(message);
 	}
 
 	public static void MessageLn2(String message, String message2) {
-		FrameGraphics.DisplayMessage(message + " " + message2);
+		MessageBay.displayMessage(message + " " + message2);
 	}
 
@@ -502,12 +503,12 @@
 			// TODO is there a built in method which will do this faster?
 
-			FrameGraphics.DisplayMessage("Copying file " + existingFile
+			MessageBay.displayMessage("Copying file " + existingFile
 					+ " to " + newFileName + "...");
 			FrameIO.copyFile(existingFile, newFileName);
-			FrameGraphics.DisplayMessage("File copied successfully");
+			MessageBay.displayMessage("File copied successfully");
 		} catch (FileNotFoundException e) {
-			FrameGraphics.DisplayMessage("Error opening file: " + existingFile);
+			MessageBay.displayMessage("Error opening file: " + existingFile);
 		} catch (Exception e) {
-			FrameGraphics.DisplayMessage("File could not be copied");
+			MessageBay.displayMessage("File could not be copied");
 		}
 	}
@@ -561,11 +562,11 @@
 			float aveTimeB = timeB * 1000F / repsPerTest / tests;
 			// Display Results
-			FrameGraphics.DisplayMessage("Average Execution Time");
-			FrameGraphics.DisplayMessage(methodNameA + ": "
+			MessageBay.displayMessage("Average Execution Time");
+			MessageBay.displayMessage(methodNameA + ": "
 					+ TimeKeeper.Formatter.format(aveTimeA) + "us");
-			FrameGraphics.DisplayMessage(methodNameB + ": "
+			MessageBay.displayMessage(methodNameB + ": "
 					+ TimeKeeper.Formatter.format(aveTimeB) + "us");
 		} catch (Exception e) {
-			FrameGraphics.ErrorMessage(e.getClass().getSimpleName() + ": "
+			MessageBay.errorMessage(e.getClass().getSimpleName() + ": "
 					+ e.getMessage());
 		}
@@ -634,6 +635,6 @@
 		// the item must link to a frame
 		if (current.getLink() == null) {
-			FrameGraphics
-					.DisplayMessage("Cannot get item from child - this item has no link");
+			MessageBay
+					.displayMessage("Cannot get item from child - this item has no link");
 			return null;
 		}
@@ -643,5 +644,5 @@
 		// if the frame could not be loaded
 		if (child == null) {
-			FrameGraphics.ErrorMessage("Could not load child frame.");
+			MessageBay.errorMessage("Could not load child frame.");
 			return null;
 		}
@@ -663,5 +664,5 @@
 		// if no item was found
 		if (item == null) {
-			FrameGraphics.DisplayMessage("No item found to copy");
+			MessageBay.displayMessage("No item found to copy");
 			return null;
 		}
Index: /trunk/src/org/expeditee/actions/NavigationActions.java
===================================================================
--- /trunk/src/org/expeditee/actions/NavigationActions.java	(revision 120)
+++ /trunk/src/org/expeditee/actions/NavigationActions.java	(revision 121)
@@ -5,7 +5,7 @@
 import org.expeditee.gui.DisplayIO;
 import org.expeditee.gui.Frame;
-import org.expeditee.gui.FrameGraphics;
 import org.expeditee.gui.FrameIO;
 import org.expeditee.gui.FrameUtils;
+import org.expeditee.gui.MessageBay;
 import org.expeditee.items.Item;
 
@@ -143,5 +143,5 @@
 		// if there is no parent frame (i.e. the user is on the home frame) //
 		if (back == null) { // No frame was on the Backup stack
-			FrameGraphics.DisplayMessage("No Parent Frame Found.");
+			MessageBay.displayMessage("No Parent Frame Found.");
 			_LastItemUsed = null; // ByRob: what is reason for setting
 			// this to null, who is going to use it????
@@ -200,5 +200,5 @@
 		} // ByRob: End of For
 
-		FrameGraphics.DisplayMessage("No more child frames found.");
+		MessageBay.displayMessage("No more child frames found.");
 	}
 
Index: /trunk/src/org/expeditee/actions/Simple.java
===================================================================
--- /trunk/src/org/expeditee/actions/Simple.java	(revision 120)
+++ /trunk/src/org/expeditee/actions/Simple.java	(revision 121)
@@ -27,4 +27,6 @@
 import org.expeditee.gui.FrameMouseActions;
 import org.expeditee.gui.FrameUtils;
+import org.expeditee.gui.FreeItems;
+import org.expeditee.gui.MessageBay;
 import org.expeditee.io.Conversion;
 import org.expeditee.items.Dot;
@@ -144,5 +146,5 @@
 		newSimpleTest.getTitleItem().setActions(actions);
 		FrameUtils.DisplayFrame(newSimpleTest, true);
-		FrameGraphics.DisplayMessage("New test created");
+		MessageBay.displayMessage("New test created");
 	}
 
@@ -206,5 +208,5 @@
 
 		FrameIO.SaveFrame(DisplayIO.getCurrentFrame(), false);
-		FrameGraphics.DisplayMessage("Starting test suite: " + _frameset,
+		MessageBay.displayMessage("Starting test suite: " + _frameset,
 				Color.CYAN);
 
@@ -257,5 +259,5 @@
 				if (passed) {
 					if (_verbose)
-						FrameGraphics.DisplayMessage("Test passed: "
+						MessageBay.displayMessage("Test passed: "
 								+ title.toString(), Item.GREEN);
 					testsPassed++;
@@ -263,5 +265,5 @@
 					testsFailed++;
 					// Print out the reason for failed tests
-					FrameGraphics.LinkedErrorMessage(errorMessage);
+					MessageBay.linkedErrorMessage(errorMessage);
 					if (Simple._stop) {
 						Simple._stop = false;
@@ -275,12 +277,12 @@
 		assert (_programsRunning == 0);
 		// Report the number of test passed and failed
-		FrameGraphics.DisplayMessage("Total tests: "
+		MessageBay.displayMessage("Total tests: "
 				+ (testsPassed + testsFailed), Color.CYAN);
 		if (testsPassed > 0)
-			FrameGraphics.DisplayMessage("Passed: " + testsPassed, Item.GREEN);
+			MessageBay.displayMessage("Passed: " + testsPassed, Item.GREEN);
 		if (testsFailed > 0)
-			FrameGraphics.DisplayMessage("Failed: " + testsFailed, Color.RED);
+			MessageBay.displayMessage("Failed: " + testsFailed, Color.RED);
 		// Remove items from the cursor...
-		Frame.FreeItems.clear();
+		FreeItems.getInstance().clear();
 
 		return testsFailed == 0;
@@ -1437,10 +1439,10 @@
 					.getValue();
 			try {
-				FrameGraphics.DisplayMessage(((Text) message).copy());
+				MessageBay.displayMessage(((Text) message).copy());
 			} catch (NullPointerException e) {
-				FrameGraphics.DisplayMessage("null");
+				MessageBay.displayMessage("null");
 			} catch (ClassCastException e) {
 				// Just ignore not text items!
-				FrameGraphics.DisplayMessage(message.toString());
+				MessageBay.displayMessage(message.toString());
 			} catch (Exception e) {
 				// Just ignore other errors
@@ -1455,7 +1457,7 @@
 
 			if (tokens[0].equals("errorln") || tokens[0].equals("errorline"))
-				FrameGraphics.ErrorMessage(message);
+				MessageBay.errorMessage(message);
 			else
-				FrameGraphics.DisplayMessageAlways(message);
+				MessageBay.displayMessageAlways(message);
 		} else if (tokens[0].equals("typeatrate")) {
 			assertMinParametreCount(tokens, 1);
@@ -1488,5 +1490,5 @@
 			try {
 				Process p = Runtime.getRuntime().exec(command);
-				FrameGraphics.DisplayMessage(command, Color.darkGray);
+				MessageBay.displayMessage(command, Color.darkGray);
 
 				BufferedReader stdInput = new BufferedReader(
@@ -1496,8 +1498,8 @@
 				String message = "";
 				while ((message = stdInput.readLine()) != null) {
-					FrameGraphics.DisplayMessage(message);
+					MessageBay.displayMessage(message);
 				}
 				while ((message = stdError.readLine()) != null) {
-					FrameGraphics.ErrorMessage(message);
+					MessageBay.errorMessage(message);
 				}
 			} catch (Exception e) {
@@ -1758,9 +1760,9 @@
 				success = FrameIO.DeleteFrame(frame);
 				if (!success && _verbose)
-					FrameGraphics.WarningMessage(errorMessage);
+					MessageBay.warningMessage(errorMessage);
 			} catch (Exception e) {
 				// If an exception is thrown then success is false
 				if (_verbose) {
-					FrameGraphics.WarningMessage(errorMessage
+					MessageBay.warningMessage(errorMessage
 							+ (e.getMessage() != null ? ". " + e.getMessage()
 									: ""));
@@ -1777,5 +1779,5 @@
 			boolean success = FrameIO.DeleteFrameset(framesetName);
 			if (!success && _verbose) {
-				FrameGraphics.WarningMessage("Error deleting " + framesetName);
+				MessageBay.warningMessage("Error deleting " + framesetName);
 			}
 			if (tokens.length > 2) {
@@ -1800,5 +1802,5 @@
 					copiedFrameset);
 			if (!success && _verbose)
-				FrameGraphics.WarningMessage("Error copying " + framesetToCopy);
+				MessageBay.warningMessage("Error copying " + framesetToCopy);
 			if (tokens.length > 3) {
 				context.getPrimitives().setValue(tokens[3],
@@ -1829,5 +1831,5 @@
 			boolean success = fileContents != null;
 			if (!success && _verbose)
-				FrameGraphics.WarningMessage("Error copying "
+				MessageBay.warningMessage("Error copying "
 						+ frameToCopy.getName());
 			if (tokens.length > 4) {
@@ -2026,6 +2028,6 @@
 					if (freeMemory < DisplayTree.GARBAGE_COLLECTION_THRESHOLD) {
 						runtime.gc();
-						FrameGraphics
-								.DisplayMessage("Force Garbage Collection!");
+						MessageBay
+								.displayMessage("Force Garbage Collection!");
 					}
 				}
@@ -2128,5 +2130,5 @@
 				success = false;
 				if (_verbose)
-					FrameGraphics.WarningMessage("Error parsing " + frameName);
+					MessageBay.warningMessage("Error parsing " + frameName);
 			}
 			// assertPrimitiveType(tokens[2], 2);
@@ -2299,5 +2301,5 @@
 			// DisplayIO.setCursorPosition(finalX, finalY);
 			FrameMouseActions.anchor(item);
-			Frame.FreeItems.clear();
+			FreeItems.getInstance().clear();
 			FrameGraphics.Repaint();
 			// FrameMouseActions.updateCursor();
@@ -2591,5 +2593,5 @@
 		_programsRunning++;
 		AgentStats.reset();
-		FrameGraphics.DisplayMessage("Running SimpleProgram...", Color.BLUE);
+		MessageBay.displayMessage("Running SimpleProgram...", Color.BLUE);
 	}
 
Index: /trunk/src/org/expeditee/agents/CopyTree.java
===================================================================
--- /trunk/src/org/expeditee/agents/CopyTree.java	(revision 120)
+++ /trunk/src/org/expeditee/agents/CopyTree.java	(revision 121)
@@ -5,7 +5,7 @@
 
 import org.expeditee.gui.Frame;
-import org.expeditee.gui.FrameGraphics;
 import org.expeditee.gui.FrameIO;
 import org.expeditee.gui.FrameUtils;
+import org.expeditee.gui.MessageBay;
 import org.expeditee.items.Item;
 
@@ -49,5 +49,5 @@
 			processFrame(zero);
 		} catch (ExistingFramesetException efe) {
-			FrameGraphics.ErrorMessage("A frameset called " + _nameTo
+			MessageBay.errorMessage("A frameset called " + _nameTo
 					+ " already exists.");
 			return false;
Index: /trunk/src/org/expeditee/agents/DefaultAgent.java
===================================================================
--- /trunk/src/org/expeditee/agents/DefaultAgent.java	(revision 120)
+++ /trunk/src/org/expeditee/agents/DefaultAgent.java	(revision 121)
@@ -2,5 +2,5 @@
 
 import org.expeditee.gui.Frame;
-import org.expeditee.gui.FrameGraphics;
+import org.expeditee.gui.MessageBay;
 import org.expeditee.gui.TimeKeeper;
 import org.expeditee.stats.SessionStats;
@@ -93,5 +93,5 @@
 		// init is now called by Actions.java
 		/*
-		 * if(!initialise(_start)){ FrameGraphics.ErrorMessage("Error
+		 * if(!initialise(_start)){ MessageBay.errorMessage("Error
 		 * initialising agent."); _running = false; return; }
 		 */
@@ -135,9 +135,9 @@
 	 */
 	protected void message(String message) {
-		FrameGraphics.DisplayMessageAlways(message);
+		MessageBay.displayMessageAlways(message);
 	}
 
 	protected void overwriteMessage(String message) {
-		FrameGraphics.OverwriteMessage(message);
+		MessageBay.overwriteMessage(message);
 	}
 
Index: /trunk/src/org/expeditee/agents/DisplayComet.java
===================================================================
--- /trunk/src/org/expeditee/agents/DisplayComet.java	(revision 120)
+++ /trunk/src/org/expeditee/agents/DisplayComet.java	(revision 121)
@@ -7,6 +7,6 @@
 import org.expeditee.gui.DisplayIO;
 import org.expeditee.gui.Frame;
-import org.expeditee.gui.FrameGraphics;
 import org.expeditee.gui.FrameIO;
+import org.expeditee.gui.MessageBay;
 import org.expeditee.items.Item;
 import org.expeditee.items.ItemUtils;
@@ -45,5 +45,5 @@
 				if (link != null && !seen.contains(linkLowerCase)) {
 					oldFrame = FrameIO.LoadFrame(linkLowerCase);
-					FrameGraphics.OverwriteMessage("Loading frames: " + link);
+					MessageBay.overwriteMessage("Loading frames: " + link);
 				}
 			}
Index: /trunk/src/org/expeditee/agents/DisplayTree.java
===================================================================
--- /trunk/src/org/expeditee/agents/DisplayTree.java	(revision 120)
+++ /trunk/src/org/expeditee/agents/DisplayTree.java	(revision 121)
@@ -3,5 +3,5 @@
 import org.expeditee.gui.DisplayIO;
 import org.expeditee.gui.Frame;
-import org.expeditee.gui.FrameGraphics;
+import org.expeditee.gui.MessageBay;
 import org.expeditee.items.Item;
 import org.expeditee.items.ItemUtils;
@@ -55,5 +55,5 @@
 		if (freeMemory < GARBAGE_COLLECTION_THRESHOLD) {
 			_runtime.gc();
-			FrameGraphics.DisplayMessage("Force Garbage Collection!");
+			MessageBay.displayMessage("Force Garbage Collection!");
 		}
 
Index: /trunk/src/org/expeditee/agents/SwitchyardTree.java
===================================================================
--- /trunk/src/org/expeditee/agents/SwitchyardTree.java	(revision 120)
+++ /trunk/src/org/expeditee/agents/SwitchyardTree.java	(revision 121)
@@ -12,5 +12,5 @@
 	@Override
 	protected Frame process(Frame frame) {
-		//FrameGraphics.DisplayMessage("Running switchyard tree...");
+		//MessageBay.displayMessage("Running switchyard tree...");
 
 		for (Text textItem : frame.getBodyTextItems(false)) {
Index: /trunk/src/org/expeditee/agents/WriteTree.java
===================================================================
--- /trunk/src/org/expeditee/agents/WriteTree.java	(revision 120)
+++ /trunk/src/org/expeditee/agents/WriteTree.java	(revision 121)
@@ -6,5 +6,5 @@
 import org.expeditee.actions.Actions;
 import org.expeditee.gui.Frame;
-import org.expeditee.gui.FrameGraphics;
+import org.expeditee.gui.MessageBay;
 import org.expeditee.io.FrameWriter;
 import org.expeditee.io.Logger;
@@ -88,5 +88,5 @@
 				// check that o is a valid treewriter
 				if (!(o instanceof TreeWriter)) {
-					FrameGraphics.WarningMessage(_format.toUpperCase()
+					MessageBay.warningMessage(_format.toUpperCase()
 							+ " format cannot be used to write trees.");
 					return false;
@@ -101,5 +101,5 @@
 			} else {
 				if (!(o instanceof FrameWriter) && !(o instanceof TreeWriter)) {
-					FrameGraphics.WarningMessage(_format.toUpperCase()
+					MessageBay.warningMessage(_format.toUpperCase()
 							+ " format cannot be used to write frames.");
 					return false;
@@ -115,6 +115,6 @@
 
 		} catch (ClassNotFoundException e) {
-			FrameGraphics
-					.WarningMessage("The agent does not exist or has incorrect parametres.");
+			MessageBay
+					.warningMessage("The agent does not exist or has incorrect parametres.");
 			return false;
 		} catch (Exception e) {
@@ -141,5 +141,5 @@
 			//System.out.println("Caught");
 			Logger.Log(e);
-			FrameGraphics.ErrorMessage("IOException in WriteTree: "
+			MessageBay.errorMessage("IOException in WriteTree: "
 					+ e.getMessage());
 			e.printStackTrace();
Index: /trunk/src/org/expeditee/gui/AttributeUtils.java
===================================================================
--- /trunk/src/org/expeditee/gui/AttributeUtils.java	(revision 120)
+++ /trunk/src/org/expeditee/gui/AttributeUtils.java	(revision 121)
@@ -476,5 +476,5 @@
 						// Display an error message if its not in our list of
 						// attributes to ignore when copying
-						FrameGraphics.WarningMessage("Attribute: '"
+						MessageBay.warningMessage("Attribute: '"
 								+ getAttribute(v.toString())
 								+ "' does not exist.");
@@ -484,5 +484,5 @@
 								.getParameterTypes())
 							types += c.getSimpleName() + " ";
-						FrameGraphics.WarningMessage("Wrong arguments for: '"
+						MessageBay.warningMessage("Wrong arguments for: '"
 								+ getAttribute(v.toString()) + "' expecting "
 								+ types.trim() + " found '"
@@ -576,5 +576,5 @@
 					e.printStackTrace();
 				} catch (InvocationTargetException e) {
-					FrameGraphics.DisplayMessage(toSet.getClass()
+					MessageBay.displayMessage(toSet.getClass()
 							.getSimpleName()
 							+ " type does not support that attribute.");
Index: /trunk/src/org/expeditee/gui/Browser.java
===================================================================
--- /trunk/src/org/expeditee/gui/Browser.java	(revision 120)
+++ /trunk/src/org/expeditee/gui/Browser.java	(revision 121)
@@ -15,4 +15,5 @@
 
 import javax.swing.JFrame;
+import javax.swing.RepaintManager;
 
 import org.expeditee.AbsoluteLayout;
@@ -48,7 +49,7 @@
 	 */
 	public static void main(String[] args) {
-		//FrameGraphics.SupressMessages(true);
+		//MessageBay.supressMessages(true);
 		_theBrowser = new Browser();
-		//FrameGraphics.SupressMessages(false);
+		//MessageBay.supressMessages(false);
 		// Why do we want to ignore repaint?
 		// _theBrowser.setIgnoreRepaint(true);
@@ -114,4 +115,9 @@
 		addComponentListener(this);
 		pack();
+		
+		// Expeditee handles its own repainting of AWT/Swing components
+		RepaintManager.setCurrentManager(ExpediteeRepaintManager.getInstance());
+		
+		
 		try {
 			Collection<String> warningMessages = Actions.Init();
@@ -129,6 +135,6 @@
 			//Must be loaded after setupGraphics if images are on the frame
 			//Turn off XRay mode and load the first frame
+			FrameUtils.loadFirstFrame(profile);
 			FrameGraphics.setMode(FrameGraphics.MODE_NORMAL, false);
-			FrameUtils.loadFirstFrame(profile);
 			DisplayIO.UpdateTitle();
 			
@@ -136,5 +142,5 @@
 			//It used to crash the program trying to print error messages up the top
 			for (String message : warningMessages)
-				FrameGraphics.WarningMessage(message);
+				MessageBay.warningMessage(message);
 
 			FrameKeyboardActions keyboardListner = new FrameKeyboardActions();
@@ -142,5 +148,5 @@
 			this.addKeyListener(keyboardListner);
 			
-			//FrameKeyboardActions.Refresh();
+			FrameKeyboardActions.Refresh();
 			//setVisible(true);
 		} catch (Exception e) {
@@ -150,5 +156,5 @@
 	}
 
-	Graphics2D g;
+	public Graphics2D g;
 
 	private void setupGraphics() {
@@ -170,5 +176,5 @@
 		// then moved back into view
 		super.paint(g);
-		FrameGraphics.Repaint();
+		FrameGraphics.ForceRepaint();
 		// System.out.println("Paint " + count++);
 	}
@@ -181,5 +187,5 @@
 		setupGraphics();
 		FrameIO.RefreshCasheImages();
-		FrameGraphics.Repaint();
+		FrameGraphics.ForceRepaint();
 	}
 
Index: /trunk/src/org/expeditee/gui/DisplayIO.java
===================================================================
--- /trunk/src/org/expeditee/gui/DisplayIO.java	(revision 120)
+++ /trunk/src/org/expeditee/gui/DisplayIO.java	(revision 121)
@@ -10,4 +10,5 @@
 import java.awt.geom.Point2D;
 import java.awt.image.MemoryImageSource;
+import java.util.ArrayList;
 import java.util.Collection;
 import java.util.LinkedList;
@@ -205,5 +206,5 @@
 
 		if (Frame.itemAttachedToCursor()) {
-			List<Item> toMove = Frame.FreeItems;
+			List<Item> toMove = FreeItems.getInstance();
 			for (Item move : toMove) {
 				move.setPosition(move.getX() + deltax, move.getY() + deltay);
@@ -333,5 +334,5 @@
 		if (frame == null)
 			return;
-
+		
 		if (_TwinFrames) {
 			if (_CurrentFrames[0] == null) {
@@ -348,5 +349,5 @@
 		if (frame == getCurrentFrame()) {
 			FrameGraphics.Repaint();
-			FrameGraphics.DisplayMessage(frame.getName()
+			MessageBay.displayMessage(frame.getName()
 					+ " is already the current frame.");
 			return;
@@ -355,4 +356,19 @@
 		}
 
+		
+		// Invalidate free items
+		if (!FreeItems.getInstance().isEmpty() && getCurrentFrame() != null) {
+	
+			// Empty free items temporarily so that the old frames buffer is repainted
+			// without the free items.
+			ArrayList<? extends Item> tmp = (ArrayList<? extends Item>)FreeItems.getInstance().clone();
+			FreeItems.getInstance().clear(); // NOTE: This will invalidate all the cleared free items
+			FrameGraphics.refresh(true);
+			FreeItems.getInstance().addAll(tmp);
+			
+			
+		}
+		
+		
 		if (_TwinFrames) {
 			// if the same frame is being shown in both sides, load a fresh
@@ -379,5 +395,5 @@
 			_CurrentFrames[getCurrentSide()] = frame;
 
-			// BROOK : TODO...
+			// BROOK : TODO... overlays and loadable widgets
 			for (Item i : _CurrentFrames[getCurrentSide()].getItems()) {
 				i.onParentStateChanged(new ItemParentStateChangedEvent(
@@ -469,5 +485,5 @@
 		}
 
-		FrameGraphics.Repaint();
+		FrameGraphics.refresh(false);
 	}
 
@@ -573,11 +589,11 @@
 		// there must be a frame to go back to
 		if (_VisitedFrames[side].size() < 1) {
-			FrameGraphics
-					.DisplayMessageOnce("You are already on the home frame");
+			MessageBay
+					.displayMessageOnce("You are already on the home frame");
 			return;
 		}
 
 		if (!FrameUtils.LeavingFrame(getCurrentFrame())) {
-			FrameGraphics.DisplayMessage("Back operation cancelled");
+			MessageBay.displayMessage("Back operation cancelled");
 			return;
 		}
Index: /trunk/src/org/expeditee/gui/Frame.java
===================================================================
--- /trunk/src/org/expeditee/gui/Frame.java	(revision 120)
+++ /trunk/src/org/expeditee/gui/Frame.java	(revision 121)
@@ -24,4 +24,5 @@
 import org.expeditee.items.InteractiveWidget;
 import org.expeditee.items.Item;
+import org.expeditee.items.ItemAppearence;
 import org.expeditee.items.ItemParentStateChangedEvent;
 import org.expeditee.items.ItemUtils;
@@ -99,6 +100,4 @@
 	// Note: Needs to be able to be iterated through (for painting)
 	private List<Item> _body = new ArrayList<Item>();
-
-	public static List<Item> FreeItems = new ArrayList<Item>();
 
 	// for drawing purposes
@@ -660,4 +659,5 @@
 		_body.add(item);
 		item.setParent(this);
+		item.invalidateCommonTrait(ItemAppearence.Added);
 
 		// If the item is a line end and has constraints with items already
@@ -717,5 +717,7 @@
 					_iWidgets.remove(((WidgetCorner) item).getWidgetSource());
 				}
-			}
+				item.invalidateCommonTrait(ItemAppearence.Removed);
+			}
+			
 		}
 	}
@@ -862,5 +864,8 @@
 		_background = back;
 		change();
-		// FrameGraphics.Repaint();
+		
+		if (this == DisplayIO.getCurrentFrame()) {
+			FrameGraphics.refresh(false);
+		}
 	}
 
@@ -1012,4 +1017,6 @@
 					toAdd.permission));
 			_vectorItems.add(i);
+			i.invalidateAll();
+			i.invalidateFill();
 		}
 		return true;
@@ -1097,5 +1104,11 @@
 	public void clearVectors() {
 		_vectors.clear();
+		
+		for (Item i : _vectorItems) { // TODO: Rethink where this should live
+			i.invalidateAll();
+			i.invalidateFill();
+		}
 		_vectorItems.clear();
+		
 	}
 
@@ -1104,8 +1117,11 @@
 			return false;
 		for (Item i : toRemove.Frame.getVectorItems()) {
+			i.invalidateAll();
+			i.invalidateFill();
 			_overlayItems.remove(i);
 			i.onParentStateChanged(new ItemParentStateChangedEvent(this,
 					ItemParentStateChangedEvent.EVENT_TYPE_REMOVED_VIA_OVERLAY,
 					toRemove.permission));
+			
 		}
 		return true;
@@ -1142,5 +1158,5 @@
 		}
 	}
-
+	
 	public void addAllOverlays(Collection<Overlay> overlays) {
 		for (Overlay o : overlays) {
@@ -1396,19 +1412,19 @@
 
 	public static boolean rubberbandingLine() {
-		return FreeItems.size() == 2
-				&& (FreeItems.get(0) instanceof Line || FreeItems.get(1) instanceof Line);
+		return FreeItems.getInstance().size() == 2
+				&& (FreeItems.getInstance().get(0) instanceof Line || FreeItems.getInstance().get(1) instanceof Line);
 	}
 
 	public static boolean itemAttachedToCursor() {
-		return FreeItems.size() > 0;
+		return FreeItems.getInstance().size() > 0;
 	}
 
 	public static boolean textItemAttachedToCursor() {
-		return itemAttachedToCursor() && FreeItems.get(0) instanceof Text;
+		return itemAttachedToCursor() && FreeItems.getInstance().get(0) instanceof Text;
 	}
 
 	public static Item getItemAttachedToCursor() {
 		if (itemAttachedToCursor())
-			return FreeItems.get(0);
+			return FreeItems.getInstance().get(0);
 
 		return null;
